Browse Source

Merge pull request #114 from nextcloud/droneLint

Add drone, lint
Mario Đanić 7 years ago
parent
commit
3757c1ab53

+ 43 - 0
.drone.yml

@@ -0,0 +1,43 @@
+pipeline:
+  compile:
+    image: nextcloudci/android:android-33
+    commands:
+      # build app and assemble APK
+      - sh -c "if [ '${FLAVOR}' != 'Lint' ]; then ./gradlew assemble${FLAVOR}; fi"
+    when:
+      matrix:
+        FLAVOR: [Generic, Gplay]
+
+  lint:
+    image: nextcloudci/android:android-33
+    commands:
+      # needs gplay
+      - export BRANCH=$(scripts/lint/getBranchName.sh $GIT_USERNAME $GIT_TOKEN $DRONE_PULL_REQUEST)
+      - scripts/lint/lint-up-wrapper.sh $GIT_USERNAME $GIT_TOKEN $BRANCH $LOG_USERNAME $LOG_PASSWORD $DRONE_BUILD_NUMBER
+    secrets: [ GIT_USERNAME, GIT_TOKEN, LOG_USERNAME, LOG_PASSWORD ]
+    when:
+      matrix:
+        FLAVOR: Lint
+        
+  notify:
+      image: drillster/drone-email
+      host: $EMAIL_HOST
+      port: 587
+      username: $EMAIL_USERNAME
+      password: $EMAIL_PASSWORD
+      from: nextcloud-drone@kaminsky.me
+      recipients_only: true
+      recipients: [ $EMAIL_RECIPIENTS ]
+      secrets: [ EMAIL_USERNAME, EMAIL_PASSWORD, EMAIL_RECIPIENTS, EMAIL_HOST ]
+      when:
+        event: push
+        status: failure
+        branch: master
+
+matrix:
+  FLAVOR:
+    - Generic
+    - Gplay
+    - Lint
+
+branches: master

+ 6 - 4
.gitignore

@@ -13,10 +13,6 @@ bin/
 gen/
 out/
 
-# Gradle files
-.gradle/
-build/
-
 # Local configuration file (sdk path, etc)
 local.properties
 
@@ -55,3 +51,9 @@ freeline.py
 freeline/
 freeline_project_description.json
 .DS_Store
+
+# Android Studio and Gradle specific entries
+.gradle/
+build/
+.idea/
+/gradle.properties

+ 1 - 1
.idea/vcs.xml

@@ -1,6 +1,6 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <project version="4">
   <component name="VcsDirectoryMappings">
-    <mapping directory="" vcs="svn" />
+    <mapping directory="" vcs="Git" />
   </component>
 </project>

+ 6 - 0
app/build.gradle

@@ -54,6 +54,12 @@ android {
         targetCompatibility JavaVersion.VERSION_1_8
     }
 
+    lintOptions {
+        abortOnError false
+        htmlReport true
+        htmlOutput file("$project.buildDir/reports/lint/lint.html")
+        disable 'MissingTranslation'
+    }
 }
 
 ext {

+ 9 - 0
scripts/lint/getBranchName.sh

@@ -0,0 +1,9 @@
+#!/bin/bash
+
+# $1: username, $2: password/token, $3: pull request number
+
+if [ -z $3 ] ; then
+    echo "master";
+else
+    curl 2>/dev/null -u $1:$2 https://api.github.com/repos/nextcloud/talk-android/pulls/$3 | grep \"ref\": | grep -v master | cut -d"\"" -f4
+fi

+ 2 - 0
scripts/lint/lint-results.txt

@@ -0,0 +1,2 @@
+DO NOT TOUCH; GENERATED BY DRONE
+      <span class="mdl-layout-title">Lint Report: 3 errors and 370 warnings</span>

+ 36 - 0
scripts/lint/lint-up-wrapper.sh

@@ -0,0 +1,36 @@
+#!/bin/sh
+
+#1: GIT_USERNAME
+#2: GIT_TOKEN
+#3: BRANCH
+#4: LOG_USERNAME
+#5: LOG_PASSWORD
+#6: DRONE_BUILD_NUMBER
+
+ruby scripts/lint/lint-up.rb $1 $2 $3
+returnValue=$?
+
+# exit codes:
+# 0: count was reduced
+# 1: count was increased
+# 2: count stayed the same
+
+echo "Branch: $3"
+
+if [ $3 = "master" -a $returnValue -ne 1 ]; then
+    echo "New master at: https://nextcloud.kaminsky.me/index.php/s/fyxdQjc7LCiy57C"
+    curl -u $4:$5 -X PUT https://nextcloud.kaminsky.me/remote.php/webdav/talk-droneLogs/master.html --upload-file app/build/reports/lint/lint.html
+    exit 0
+else
+    if [ -e $6 ]; then
+        6="master-"$(date +%F)
+    fi
+    echo "New results at https://nextcloud.kaminsky.me/index.php/s/fyxdQjc7LCiy57C ->" $6.html
+    curl -u $4:$5 -X PUT https://nextcloud.kaminsky.me/remote.php/webdav/talk-droneLogs/$6.html --upload-file app/build/reports/lint/lint.html
+    
+    if [ $returnValue -eq 2 ]; then
+        exit 0
+    else
+        exit $returnValue
+    fi  
+fi

+ 199 - 0
scripts/lint/lint-up.rb

@@ -0,0 +1,199 @@
+## Script from https://github.com/tir38/android-lint-entropy-reducer at 07.05.2017
+# adapts to drone, use git username / token as parameter
+
+Encoding.default_external = Encoding::UTF_8
+Encoding.default_internal = Encoding::UTF_8
+
+puts "=================== starting Android Lint Entropy Reducer ===================="
+
+# get args
+git_user, git_token, git_branch = ARGV
+
+# ========================  SETUP ============================
+
+# User name for git commits made by this script.
+TRAVIS_GIT_USERNAME = String.new("Drone CI server")
+
+# File name and relative path of generated Lint report. Must match build.gradle file:
+#   lintOptions {
+#       htmlOutput file("[FILE_NAME].html")
+#   }
+LINT_REPORT_FILE = String.new("app/build/reports/lint/lint.html")
+
+# File name and relative path of previous results of this script.
+PREVIOUS_LINT_RESULTS_FILE=String.new("scripts/lint/lint-results.txt")
+
+# Flag to evaluate warnings. true = check warnings; false = ignore warnings
+CHECK_WARNINGS = true
+
+# File name and relative path to custom lint rules; Can be null or "".
+CUSTOM_LINT_FILE = String.new("")
+
+# ================ SETUP DONE; DON'T TOUCH ANYTHING BELOW  ================
+
+require 'fileutils'
+require 'pathname'
+require 'open3'
+
+# since we need the xml-simple gem, and we want this script self-contained, let's grab it just when we need it
+begin
+    gem "xml-simple"
+    rescue LoadError
+    system("gem install xml-simple")
+    Gem.clear_paths
+end
+
+require 'xmlsimple'
+
+# add custom Lint jar
+if !CUSTOM_LINT_FILE.nil? &&
+    CUSTOM_LINT_FILE.length > 0
+
+    ENV["ANDROID_LINT_JARS"] = Dir.pwd + "/" + CUSTOM_LINT_FILE
+    puts "adding custom lint rules to default set: "
+    puts ENV["ANDROID_LINT_JARS"]
+end
+
+# run Lint
+puts "running Lint..."
+system './gradlew clean assembleGplay lint'
+
+# confirm that Lint ran w/out error
+result = $?.to_i
+if result != 0
+    puts "FAIL: failed to run ./gradlew clean assembleGplay lint"
+    exit 1
+end
+
+# find Lint report file
+lint_reports = Dir.glob(LINT_REPORT_FILE)
+if lint_reports.length == 0
+    puts "Lint HTML report not found."
+    exit 1
+end
+lint_report = String.new(lint_reports[0])
+
+# find error/warning count string in HTML report
+error_warning_string = ""
+File.open lint_report do |file|
+  error_warning_string = file.find { |line| line =~ /([0-9]* error[s]? and )?[0-9]* warning[s]?/ }
+end
+
+# find number of errors
+error_string = error_warning_string.match(/[0-9]* error[s]?/)
+
+if (error_string.nil?)
+    current_error_count = 0
+else
+    current_error_count = error_string[0].match(/[0-9]*/)[0].to_i
+end
+
+puts "found errors: " + current_error_count.to_s
+
+# find number of warnings
+if CHECK_WARNINGS == true
+    warning_string = error_warning_string.match(/[0-9]* warning[s]?/)[0]
+    current_warning_count = warning_string.match(/[0-9]*/)[0].to_i
+    puts "found warnings: " + current_warning_count.to_s
+end
+
+# get previous error and warning counts from last successful build
+
+previous_results = false
+
+previous_lint_reports = Dir.glob(PREVIOUS_LINT_RESULTS_FILE)
+if previous_lint_reports.nil? ||
+    previous_lint_reports.length == 0
+
+    previous_lint_report = File.new(PREVIOUS_LINT_RESULTS_FILE, "w") # create for writing to later
+else
+    previous_lint_report = String.new(previous_lint_reports[0])
+
+    previous_error_warning_string = ""
+    File.open previous_lint_report do |file|
+      previous_error_warning_string = file.find { |line| line =~ /([0-9]* error[s]? and )?[0-9]* warning[s]?/ }
+    end
+
+    unless previous_error_warning_string.nil?
+        previous_results = true
+
+        previous_error_string = previous_error_warning_string.match(/[0-9]* error[s]?/)
+        if previous_error_string.nil?
+            previous_error_string = "0 errors"
+        else
+            previous_error_string = previous_error_string[0]
+        end
+        previous_error_count = previous_error_string.match(/[0-9]*/)[0].to_i
+        puts "previous errors: " + previous_error_count.to_s
+
+        if CHECK_WARNINGS == true
+            previous_warning_string = previous_error_warning_string.match(/[0-9]* warning[s]?/)
+            if previous_warning_string.nil?
+                previous_warning_string = "0 warnings"
+            else
+                previous_warning_string = previous_warning_string[0]
+            end
+            previous_warning_count = previous_warning_string.match(/[0-9]*/)[0].to_i
+            puts "previous warnings: " + previous_warning_count.to_s
+        end
+    end
+end
+
+# compare previous error count with current error count
+if previous_results == true  &&
+    current_error_count > previous_error_count
+    puts "FAIL: error count increased"
+    exit 1
+end
+
+# compare previous warning count with current warning count
+if CHECK_WARNINGS  == true &&
+    previous_results == true &&
+    current_warning_count > previous_warning_count
+
+    puts "FAIL: warning count increased"
+    exit 1
+end
+
+# check if warning and error count stayed the same
+if  previous_results == true &&
+    current_error_count == previous_error_count &&
+    current_warning_count == previous_warning_count
+
+    puts "SUCCESS: count stayed the same"
+    exit 2
+end
+
+# either error count or warning count DECREASED
+
+# write new results to file (will overwrite existing, or create new)
+File.write(previous_lint_report, "DO NOT TOUCH; GENERATED BY DRONE\n" + error_warning_string)
+
+# push changes to github (if this script is run locally, we don't want to overwrite git username and email, so save temporarily)
+previous_git_username, _ = Open3.capture2('git config user.name')
+previous_git_username = previous_git_username.strip
+
+previous_git_email, _ = Open3.capture3('git config user.email')
+previous_git_email = previous_git_email.strip
+
+# update git user name and email for this script
+system ("git config --local user.name '"  + git_user + "'")
+system ("git config --local user.email '.'") # set email blank
+system ("git remote rm origin")
+system ("git remote add origin https://" + git_user + ":" + git_token + "@github.com/nextcloud/talk-android")
+
+# add previous Lint result file to git
+system ('git add ' + PREVIOUS_LINT_RESULTS_FILE)
+
+# commit changes; Add "skip ci" so that we don't accidentally trigger another Drone build
+system ('git commit -m "Drone: update Lint results to reflect reduced error/warning count [skip ci]" ')
+
+# push to origin
+system ('git push origin HEAD:' + git_branch)
+
+# restore previous git user name and email
+system("git config --local user.name '#{previous_git_username}'")
+system("git config --local user.email '#{previous_git_email}'")
+
+puts "SUCCESS: count was reduced"
+exit 0 # success